import Utilities.waveform_creator_problem_6 as wc

import Utilities.gui_creator as gc

import Utilities.plot_creator as pc



def calculate_plot_waveform():

    

    num, samp_freq = gc.get_dig_entries(var_num,

                                        var_samp_freq)

    a, f, shape = gc.get_wav_entries(var_a, var_f,

                                     var_shape)

    win_type = gc.get_window_option(var_window)



    t = wc.create_time_data(num, samp_freq)

    y = wc.create_waveform_data(t, a, f, shape)



    win = wc.create_window(win_type, num)

    y = y*win



    freq_positive, amp_positive = wc.fft_mag_only(y, num,

                                                 samp_freq)



    pc.update_plot(ax, canvas, freq_positive, amp_positive,

                   label_x, label_y, marker='-')



    freq_est,amp_est = wc.estimated_freq_amp(freq_positive,

                                             amp_positive,

                                             num, win)

    lbl_freq.config(text=f'{freq_est:.2f}')

    lbl_amp.config(text=f'{amp_est:.2f}')

                                   

    return





label_x, label_y = 'Frequency (Hz)', 'Amplitude'



root = gc.create_window(title='FFT (Magnitude Only)',

                         size= '1000x500')

control_box,right_frame = gc.create_frames(root)



var_num, var_samp_freq = gc.digitizing_control(control_box)

var_a, var_f, var_shape = gc.waveform_control(control_box)

var_window = gc.window_control(control_box)



lbl_freq = gc.create_indicator(control_box,

                       label_1='Estimated Frequency (Hz)',

                       char_width=15)

lbl_amp = gc.create_indicator(control_box,

                       label_1='Estimated Amplitude',

                       char_width=15)



ax,canvas = pc.create_plot(right_frame)

pc.update_plot(ax, canvas, [], [], label_x, label_y)



gc.action_button(control_box,label='Submit',

                 action=calculate_plot_waveform)



root.mainloop()

