import Utilities.waveform_creator_problem_1 as wc
import Utilities.gui_creator as gc
import Utilities.plot_creator as pc

#Choose Number of Point = 3000, Sampling Frequency (Hz) = 1000,
# Shape = User-Defined

def calculate_plot_waveform():
    
    num, samp_freq = gc.get_dig_entries(var_num,
                                        var_samp_freq)
    a, f, shape = gc.get_wav_entries(var_a, var_f,
                                     var_shape)

    t = wc.create_time_data(num, samp_freq)
    y = wc.create_waveform_data(t, a, f, shape)
    
    pc.update_plot(ax, canvas, 1000*t, y, label_x, label_y,
                   marker='-')

    return


label_x, label_y = 'Time (ms)', 'Displacement'

root = gc.create_window(title = 'Waveform Simulator',
                        size='1000x500')
control_box, right_frame = gc.create_frames(root)

var_num, var_samp_freq = gc.digitizing_control(control_box)
var_a, var_f, var_shape = gc.waveform_control(control_box)

ax, canvas = pc.create_plot(right_frame)
pc.update_plot(ax, canvas, [], [],label_x, label_y)

btn = gc.action_button(control_box, label='Submit',
                       action=calculate_plot_waveform)

root.mainloop()
