import math
import matplotlib.pyplot as plt
import matplotlib.animation as animation
import matplotlib.backends.backend_tkagg as bt
import tkinter as tk
import Utilities.nidaq_operations as no

a = 5
num, delta_t = 100, 0.5
t, y = [], []

root = tk.Tk()
root.title('Data Logger')
root.geometry('800x600')

channel_name = 'Dev1/ai0'
task = no.create_ai_task(channel_name)

def stop():
    
    ani.pause()
    
    return

btn = tk.Button(root, text="Stop Plot", command=stop)
btn.pack()

fig, ax = plt.subplots(layout='constrained')
line, = plt.plot(t, y)
canvas = bt.FigureCanvasTkAgg(fig, root)
canvas.get_tk_widget().pack()


def init():
    
    ax.set_xlim(0, (num-1)*delta_t)
    ax.set_ylim(-a, a)
    ax.set_xlabel('Time (s)')
    ax.set_ylabel('Voltage (V)')

    return line,

def animate(i,t,y):
    
    t_i = i*delta_t
    y_i = task.read()

    t.append(t_i)
    y.append(y_i)
    print(y_i)
    line.set_data(t, y)

    return line,

ani = animation.FuncAnimation(fig, animate, frames=num,
                              fargs=(t,y), interval=delta_t*1000,
                              init_func=init, repeat=False,
                              blit=True)

canvas.draw()

root.mainloop()
